

#include "main.h"
#include "hmc5883l.h"


#include <math.h>
#include <stdio.h>
#include "sh1106.h"
#include "selector.h"



float bearing = 0.0;

void ms5611_run(int x_offset, int y_offset, float rad) {


    int x_arr[7];
    int y_arr[7];
    int z_arr[7];



    for (int i = 0; i < 7; i++) {

        char * buffer1 = get_heading();


        int mag_x_raw_arr = ((buffer1[0] << 8) | buffer1[1]);
        int mag_y_raw_arr = ((buffer1[4] << 8) | buffer1[5]);
        int mag_z_raw_arr = ((buffer1[2] << 8) | buffer1[3]);

        x_arr[i] = mag_x_raw_arr;
        y_arr[i] = mag_y_raw_arr;
        z_arr[i] = mag_z_raw_arr;


    }

    unsigned long inner, outer, temp;
    for (outer = 0; outer < 7 - 1; outer++) {
        for (inner = outer + 1; inner < 7; inner++) {
            if (x_arr[outer] > x_arr[inner]) {
                temp = x_arr[outer];
                x_arr[outer] = x_arr[inner];
                x_arr[inner] = temp;
            }
        }
    }



    for (outer = 0; outer < 7 - 1; outer++) {
        for (inner = outer + 1; inner < 7; inner++) {
            if (y_arr[outer] > y_arr[inner]) {
                temp = y_arr[outer];
                y_arr[outer] = y_arr[inner];
                y_arr[inner] = temp;
            }
        }
    }



    for (outer = 0; outer < 7 - 1; outer++) {
        for (inner = outer + 1; inner < 7; inner++) {
            if (z_arr[outer] > z_arr[inner]) {
                temp = z_arr[outer];
                z_arr[outer] = z_arr[inner];
                z_arr[inner] = temp;
            }
        }
    }



    int mag_x_raw = (x_arr[2] + x_arr[3] + x_arr[4]) / 3;
    int mag_y_raw = (y_arr[2] + y_arr[3] + y_arr[4]) / 3;
    int mag_z_raw = (z_arr[2] + z_arr[3] + z_arr[4]) / 3;



    float compass_gain_fact = 1.22;


    float compass_x_scal = mag_x_raw - x_offset + rad;
    float compass_y_scal = mag_y_raw - y_offset + rad;
    float compass_z_scal = mag_z_raw;



    float bearing_new;
    float compass_rad2degree = 57.3;

    if (compass_y_scal > 0) {
        bearing_new = 90 - atan(compass_x_scal / compass_y_scal) * compass_rad2degree;
    } else if (compass_y_scal < 0) {
        bearing_new = 270 - atan(compass_x_scal / compass_y_scal) * compass_rad2degree;
    } else if (compass_y_scal == 0 & compass_x_scal < 0) {
        bearing_new = 180;
    } else {
        bearing_new = 0;
    }



    char headingrrr[25];
    sprintf(headingrrr, "%3.0f", bearing_new);
    UG_PutString(15, 35, headingrrr);
    UG_PutString(75, 35, "heading");
    put_sh1106();


    if (bearing_new - bearing >= 3.75) {
        if (bearing_new - bearing <= 180.0) {
            while (bearing_new - bearing >= 3.75) {
                bearing += 7.5;
                selector(bearing);
            }
        } else {
            while (bearing_new - bearing >= 3.75) {
                bearing -= 7.5;
                if (bearing <= 0.0) {
                    bearing = 360.0;
                }
                selector(bearing);
            }
        }
    }


    if (bearing - bearing_new > 3.75) {
        if (bearing - bearing_new <= 180.0) {
            while (bearing - bearing_new >= 3.75) {
                bearing -= 7.5;
                selector(bearing);
            }
        } else {
            while (bearing - bearing_new >= 3.75) {
                bearing += 7.5;
                if (bearing >= 360.0) {
                    bearing = 0.0;
                }
                selector(bearing);
            }
        }
    }
}
