


#include "main.h"
#include "i2c.h"
#include "mpu6050.h"



void mpu6050_init(void) {

    StartI2C();
    WriteI2C(MPU6050_ADDRESS);
    IdleI2C();
    WriteI2C(MPU6050_USER_CTRL);
    IdleI2C();
    WriteI2C(0x00);
    IdleI2C();
    StopI2C();


    StartI2C();
    WriteI2C(MPU6050_ADDRESS);
    IdleI2C();
    WriteI2C(MPU6050_INT_PIN_CFG);
    IdleI2C();
    WriteI2C(0x02);
    IdleI2C();
    StopI2C();


    StartI2C();
    WriteI2C(MPU6050_ADDRESS);
    IdleI2C();
    WriteI2C(MPU6050_PWR_MGMT_1);
    IdleI2C();
    WriteI2C(0x00);
    IdleI2C();
    StopI2C();

}

char get_mpu6050_accel(void) {



    StartI2C();
    IdleI2C();
    WriteI2C(MPU6050_ADDRESS);
    IdleI2C();
    WriteI2C(MPU6050_ACCEL_XOUT_H);
    IdleI2C();
    StopI2C();
    IdleI2C();

    StartI2C();
    IdleI2C();
    WriteI2C(0xd1);
    IdleI2C();



    char buffer3[6];
    char i;
    for (i = 0; i < 6; i++) {
        delay_ms(10);

        buffer3[i] = ReadI2C();

        if (i == 5) {
            NotAckI2C();
        } else {
            AckI2C();
            IdleI2C();
        }
    }
    return buffer3;

}

int get_mpu6050_temp(void) {



    StartI2C();
    IdleI2C();
    WriteI2C(MPU6050_ADDRESS);
    IdleI2C();
    WriteI2C(MPU6050_TEMP_OUT_H);
    IdleI2C();
    StopI2C();
    IdleI2C();

    StartI2C();
    IdleI2C();
    WriteI2C(0xd1);
    IdleI2C();

    int temp = 0;
    temp = temp + (ReadI2C() << 8);
    IdleI2C();
    AckI2C();

    temp = temp + ReadI2C();
    IdleI2C();
    NotAckI2C();

    StopI2C();
    IdleI2C();
    NOP();
    return temp;

}