#include <xc.h>
//#include "gy86.h"
#include "ms5611.h"
#include "i2c.h"
#include "main.h"
#include "extender.h"
//#include "sh1106.h"
#include "hmc5883l.h"
#include "common.h"

void ms5611_init(void) {
    StartI2C();
    WriteI2C(Address_write);
    IdleI2C();
    WriteI2C(Reset);
    IdleI2C();
    StopI2C();
}

unsigned long get_ms5611_pressure(int x_offset, int y_offset, float rad) {

    StartI2C();
    WriteI2C(Address_write);
    IdleI2C();
    WriteI2C(D1_OSR_4096);
    IdleI2C();
    StopI2C();

    ms5611_run(x_offset, y_offset, rad);

    StartI2C();
    WriteI2C(Address_write);
    IdleI2C();
    NOP();
    WriteI2C(ADC_Read);
    IdleI2C();
    StopI2C();

    StartI2C();
    WriteI2C(Address_read);
    IdleI2C();

    unsigned long press_data = 0;
    press_data = press_data + ReadI2C() << 8;
    AckI2C();
    press_data = press_data + ReadI2C() << 8;
    AckI2C();
    press_data = press_data + ReadI2C();
    NotAckI2C();
    StopI2C();

    return press_data;

}


unsigned long get_ms5611_temperature(int x_offset, int y_offset, float rad) {

    StartI2C();
    WriteI2C(Address_write);
    IdleI2C();
    WriteI2C(D2_OSR_4096);
    IdleI2C();
    StopI2C();

    ms5611_run(x_offset, y_offset, rad);

    StartI2C();
    WriteI2C(Address_write);
    IdleI2C();
    WriteI2C(ADC_Read);
    IdleI2C();
    StopI2C();


    StartI2C();
    WriteI2C(Address_read);
    IdleI2C();


    unsigned long temp_data = 0;
    temp_data = temp_data + ReadI2C() << 8;
    AckI2C();

    temp_data = temp_data + ReadI2C() << 8;
    AckI2C();

    temp_data = temp_data + ReadI2C();
    NotAckI2C();

    StopI2C();

    return temp_data;

}

unsigned int get_c(char c) {

    StartI2C();
    WriteI2C(0xee);
    WriteI2C(0x1e);
    IdleI2C();
    StopI2C();

    delay_ms(10);

    StartI2C();
    WriteI2C(0xee);
    WriteI2C(c);
    IdleI2C();
    StopI2C();

    delay_ms(10);

    StartI2C();
    WriteI2C(0xef);
    IdleI2C();


    unsigned int v = 0;
    v = v + (ReadI2C() << 8);
    AckI2C();
    v = v + ReadI2C();
    AckI2C();
    StopI2C();

    return v;

}

