




void ms5611_init(void);
unsigned long get_ms5611_temperature(int x_offset, int y_offset, float rad);
unsigned long get_ms5611_pressure(int x_offset, int y_offset, float rad);
unsigned int get_c(char c);


unsigned long get_gy86_temperature(void);

#define Address_write 0xee
#define Address_read 0xef
#define Reset 0x1E
#define ADC_Read 0x00

// OSR (Over Sampling Ratio) uncompensated pressure D1 constants
#define D1_OSR_256 0x40
#define D1_OSR_512 0x42
#define D1_OSR_1024 0x44
#define D1_OSR_2048 0x46
#define D1_OSR_4096 0x48

// OSR (Over Sampling Ratio) uncompensated temperature D2 constants
#define D2_OSR_256 0x50
#define D2_OSR_512 0x52
#define D2_OSR_1024 0x54
#define D2_OSR_2048 0x56
#define D2_OSR_4096 0x58


#define PROM_Read_C1 0xa2
#define PROM_Read_C2 0xa4
#define PROM_Read_C3 0xa6
#define PROM_Read_C4 0xa8
#define PROM_Read_C5 0xaa
#define PROM_Read_C6 0xac




// addresses of the device
#define MS561101BA_ADDR_CSB_HIGH  0x76   //CBR=1 0x76 I2C address when CSB is connected to HIGH (VCC)
#define MS561101BA_ADDR_CSB_LOW   0x77   //CBR=0 0x77 I2C address when CSB is connected to LOW (GND)




// registers of the device
#define MS561101BA_D1 0x40
#define MS561101BA_D2 0x50
#define MS561101BA_RESET 0x1E

// D1 and D2 result size (bytes)
#define MS561101BA_D1D2_SIZE 3

// OSR (Over Sampling Ratio) constants
#define MS561101BA_OSR_256 0x00
#define MS561101BA_OSR_512 0x02
#define MS561101BA_OSR_1024 0x04
#define MS561101BA_OSR_2048 0x06
#define MS561101BA_OSR_4096 0x08

#define MS561101BA_PROM_BASE_ADDR 0xA2 
#define MS561101BA_PROM_REG_COUNT 6 
#define MS561101BA_PROM_REG_SIZE 2 